format PE GUI 4.0
include '%fasminc%\win32a.inc'

ID_CAPTION	   = 101
ID_MESSAGE	   = 102
ID_ICONERROR	   = 201
ID_ICONINFORMATION = 202
ID_ICONQUESTION    = 203
ID_ICONWARNING	   = 204
ID_TOPMOST	   = 301

	xor	ebx, ebx
	invoke	GetModuleHandle, ebx
	invoke	DialogBoxParam, eax, 37, HWND_DESKTOP, DialogProc, ebx
	test	eax, eax
	jz	exit
  exit:
	invoke	ExitProcess, ebx

proc DialogProc, hwnddlg, msg, wparam, lparam
	push	ebx esi edi
	cmp	[msg], WM_INITDIALOG
	je	wminitdialog
	cmp	[msg], WM_COMMAND
	je	wmcommand
	cmp	[msg], WM_CLOSE
	je	wmclose
	xor	eax, eax
	jmp	finish
  wminitdialog:
	jmp	processed
  wmcommand:
	cmp	[wparam], BN_CLICKED shl 16 + IDCANCEL
	je	wmclose
	cmp	[wparam], BN_CLICKED shl 16 + IDOK
	jne	processed
	invoke	GetDlgItemText, [hwnddlg], ID_CAPTION, function, 40h

	mov	eax, function
	xor	edx, edx				; edx == 0, coz it'll contain hash
calc_hash:
	rol	edx, 3
	xor	dl, byte [eax]			       ; xor dl with current character
	inc	eax				       ; character shift
	cmp	byte [eax], 0			       ; is we in the end of chain?
	jnz	calc_hash

	xchg	eax, edx
	mov	ecx, 8

      @calc_loop:
	xor	edx, edx
	mov	ebx, 16
	div	ebx

	cmp	dl, 9
	jg	@notdec
	add	dl, 30h
	jmp	@hashsum
	      @notdec:
		add	dl, 37h
      @hashsum:
	mov	byte [hash + ecx], dl
	loop	@calc_loop

	mov	byte [hash], '0'
	mov	word [hash + 9], 'h' + 0

	invoke	SetDlgItemText, [hwnddlg], ID_MESSAGE, hash

	jmp	processed

  wmclose:
	invoke	EndDialog, [hwnddlg], 0

  processed:
	xor	eax, eax
	inc	eax
  finish:
	pop	edi esi ebx
	return
endp

  function rb 256
  hash	   rb 11

section '.idata' import data readable writeable

  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL'

  import kernel,\
	 GetModuleHandle,'GetModuleHandleA',\
	 ExitProcess,'ExitProcess'

  import user,\
	 DialogBoxParam,'DialogBoxParamA',\
	 EndDialog,'EndDialog',\
	 GetDlgItemText,'GetDlgItemTextA',\
	 SetDlgItemText,'SetDlgItemTextA'

section '.rsrc' resource data readable

  directory RT_DIALOG,dialogs

  resource dialogs,\
	   37,LANG_ENGLISH+SUBLANG_DEFAULT,demonstration

  dialog demonstration,'Calculate hash of the function',70,70,190,175,WS_CAPTION+WS_POPUP+WS_SYSMENU+DS_MODALFRAME
    dialogitem 'STATIC','&Function:',-1,10,10,70,8,WS_VISIBLE
    dialogitem 'EDIT','',ID_CAPTION,10,20,170,13,WS_VISIBLE+WS_BORDER+WS_TABSTOP
    dialogitem 'STATIC','&Hash:',-1,10,40,70,8,WS_VISIBLE
    dialogitem 'EDIT','',ID_MESSAGE,10,50,170,13,WS_VISIBLE+WS_BORDER+WS_TABSTOP+ES_AUTOHSCROLL
    dialogitem 'BUTTON','&Calculate',IDOK,85,150,45,15,WS_VISIBLE+WS_TABSTOP+BS_DEFPUSHBUTTON
    dialogitem 'BUTTON','&Exit',IDCANCEL,135,150,45,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
  enddialog